<script lang="ts">
import Vue from 'vue';
import { IsMobileMixin } from '../../mixins';
import HeroCard from './hero-card.vue';

export default Vue.extend({
  name: 'HeroScrollGallery',
  components: {
    HeroCard,
  },
  mixins: [IsMobileMixin],
  props: {
    controls: {
      type: Object,
      required: true,
      default: () => {},
    },
    slides: {
      type: Array,
      required: true,
      default: () => [],
    },
  },
  data() {
    return {
      pressed: false,
      pos: {},
      scrollPosition: 0,
      scrollPercentage: 0,
      test: 0,
      currentStep: 0,
      totalItems: [],
      isUsingButtons: false,
      scrollDistance: 0,
      animateHero: false,
      userHasScrolled: false,
      animationTimeout: null,
      inactiveArrow: true,
      hasScroll: true,
    };
  },
  mounted() {
    window.addEventListener('load', () => {
      this.animateHero = true;
      this.$refs.items[0].onanimationend = () => {
        this.animateHero = false;
        if (!this.userHasScrolled) {
          // checks if scrolling is false before creating the timeout
          this.animationTimeout = setTimeout(() => {
            if (!this.userHasScrolled) {
              // check if scrolling still false before triggering the animation again
              this.animateHero = true;
            }
          }, 3500);
        } else {
          clearTimeout(this.animationTimeout);
        }
      };
    });
    this.checkHasScroll();
    window.addEventListener('resize', this.checkHasScroll);
  },
  destroyed() {
    window.removeEventListener('resize', this.checkHasScroll);
  },
  methods: {
    checkHasScroll() {
      this.hasScroll =
        this.$refs.wrapper.scrollWidth > this.$refs.wrapper.offsetWidth;
    },
    mouseDown(e) {
      if (!this.isMobile) {
        this.$refs.wrapper.style.userSelect = 'none';
        this.pos = {
          left: this.$refs.wrapper.scrollLeft,
          x: e.clientX,
        };
        this.$refs.wrapper.addEventListener('mousemove', this.mouseMoveHandler);
        this.$refs.wrapper.addEventListener('mouseup', this.mouseUpHandler);
      }
    },
    mouseMoveHandler(e) {
      this.pressed = true;
      this.$refs.wrapper.style.cursor = 'grabbing';
      const dx = e.clientX - this.pos.x;
      this.scrollPosition = this.pos.left - dx;
      this.$refs.wrapper.scrollLeft = this.scrollPosition;
    },
    mouseUpHandler() {
      this.$refs.wrapper.removeEventListener(
        'mousemove',
        this.mouseMoveHandler,
      );
      this.$refs.wrapper.removeEventListener('mouseup', this.mouseUpHandler);
      this.pressed = false;
      this.$refs.wrapper.style.cursor = 'grab';
      this.$refs.wrapper.style.removeProperty('user-select');
    },
    onScroll() {
      this.userHasScrolled = true;
      const wrapperWidth =
        this.$refs.wrapper.scrollWidth - this.$refs.wrapper.clientWidth;
      this.scrollPercentage =
        (this.$refs.wrapper.scrollLeft / wrapperWidth) * 100;
      if (this.scrollPercentage > 0) {
        this.inactiveArrow = false;
      } else {
        this.inactiveArrow = true;
      }
    },
    scrollOnButtonPrev() {
      this.setScrollDistance();
      this.$refs.wrapper.scrollLeft -= this.scrollDistance;
    },
    scrollOnButtonNext() {
      this.setScrollDistance();
      this.$refs.wrapper.scrollLeft += this.scrollDistance;
    },
    setScrollDistance() {
      const stepsBywidth = Math.ceil(
        this.$refs.wrapper.scrollWidth / this.$refs.wrapper.clientWidth,
      );
      this.scrollDistance =
        (this.$refs.wrapper.scrollWidth - this.$refs.wrapper.clientWidth) /
        (stepsBywidth - 1);
    },
    freeTrialClick() {
      this.$emit('hero-free-trial-cta-click');
    },
  },
});
</script>

<template>
  <section class="hero-scroll-gallery">
    <div
      ref="container"
      class="hero-scroll-gallery__container"
      :class="{ 'hero-scroll-gallery__container--animate-hero': animateHero }"
    >
      <SlpContainer class="hero-scroll-gallery__hide-on-desktop">
        <div class="hero-scroll-gallery__content-block">
          <Badge v-if="slides[0].badge" :badge="slides[0].badge" />
          <SlpTypography tag="h1" variant="heading1-bold">{{
            slides[0].title
          }}</SlpTypography>

          <SlpTypography tag="h2" variant="body1" class="subtitle slp-mt-16">
            <span v-html="slides[0].blurb"></span>
          </SlpTypography>

          <div>
            <SlpButton
              v-if="slides[0].primary_button.text.includes('free trial')"
              variant="primary"
              :data-ga-name="slides[0].primary_button.data_ga_name"
              :data-ga-location="slides[0].primary_button.data_ga_location"
              :href="slides[0].primary_button.link"
              class="slp-mr-16"
              @click.native="freeTrialClick()"
              >{{ slides[0].primary_button.text }}
            </SlpButton>
            <SlpButton
              v-else-if="slides[0].primary_button?.link"
              variant="primary"
              :data-ga-name="slides[0].primary_button.data_ga_name"
              :data-ga-location="slides[0].primary_button.data_ga_location"
              :href="slides[0].primary_button.link"
              class="slp-mr-16"
              >{{ slides[0].primary_button.text }}
            </SlpButton>
            <SlpButton
              v-if="slides[0].secondary_button?.link"
              variant="tertiary"
              class="homepage-hero__secondary-button"
              :href="slides[0].secondary_button.link"
              :data-ga-name="slides[0].secondary_button.data_ga_name"
              :data-ga-location="slides[0].secondary_button.data_ga_location"
              >{{ slides[0].secondary_button.text }}
              <SlpIcon
                :name="slides[0].secondary_button.icon.name"
                :variant="slides[0].secondary_button.icon.variant"
                size="medium"
                class="hero-scroll-gallery__content-icon"
              />
            </SlpButton>
          </div>
        </div>
      </SlpContainer>

      <div
        ref="wrapper"
        class="hero-scroll-gallery__wrapper"
        :class="{ 'hero-scroll-gallery__wrapper--pressed': pressed }"
        @mousedown="mouseDown($event)"
        @scroll="onScroll"
      >
        <div
          v-for="item in slides"
          :key="item.title"
          ref="items"
          class="hero-scroll-gallery__item"
          :class="`hero-scroll-gallery__item--${item.type}`"
        >
          <HeroCard v-if="item.type == 'card'" :data="item"></HeroCard>
          <div v-if="item.type == 'block'">
            <div class="hero-scroll-gallery__content-block">
              <Badge v-if="item.badge" :badge="item.badge" />
              <SlpTypography tag="h1" variant="heading2-bold">{{
                item.title
              }}</SlpTypography>

              <SlpTypography
                tag="h2"
                variant="body1"
                class="subtitle slp-my-16"
              >
                <span v-html="item.blurb"></span>
              </SlpTypography>

              <div class="slp-mb-16 slp-mt-24">
                <SlpButton
                  v-if="item.primary_button.text.includes('free trial')"
                  variant="primary"
                  :data-ga-name="item.primary_button.data_ga_name"
                  :data-ga-location="item.primary_button.data_ga_location"
                  :href="item.primary_button.link"
                  class="slp-mr-16"
                  @click.native="freeTrialClick()"
                  >{{ item.primary_button.text }}
                </SlpButton>
                <SlpButton
                  v-else-if="item.primary_button?.link"
                  variant="primary"
                  :data-ga-name="item.primary_button.data_ga_name"
                  :data-ga-location="item.primary_button.data_ga_location"
                  :href="item.primary_button.link"
                  class="slp-mr-16"
                  >{{ item.primary_button.text }}
                </SlpButton>
                <SlpButton
                  v-if="item.secondary_button?.link"
                  variant="tertiary"
                  class="homepage-hero__secondary-button"
                  :href="item.secondary_button.link"
                  :data-ga-name="item.secondary_button.data_ga_name"
                  :data-ga-location="item.secondary_button.data_ga_location"
                  >{{ item.secondary_button.text }}
                  <SlpIcon
                    :name="item.secondary_button.icon.name"
                    :variant="item.secondary_button.icon.variant"
                    size="medium"
                    class="hero-scroll-gallery__content-icon"
                  />
                </SlpButton>
              </div>
            </div>
          </div>
          <div v-if="item.type == 'image'">
            <img alt="" :src="item.src" class="slp-mb-16" preload />
          </div>
        </div>
      </div>
      <div v-if="hasScroll" class="hero-scroll-gallery__indicator">
        <SlpButton variant="icon" @click.native="scrollOnButtonPrev">
          <SlpIcon
            name="arrow-left"
            variant="product"
            size="medium"
            class="hero-scroll-gallery__icon"
            :class="{ 'hero-scroll-gallery__icon--inactive': inactiveArrow }"
          />
          {{ controls.prev }}
        </SlpButton>
        <div class="hero-scroll-gallery__line">
          <div
            class="hero-scroll-gallery__position"
            :style="{ width: scrollPercentage + '%' }"
          ></div>
        </div>
        <SlpButton variant="icon" @click.native="scrollOnButtonNext">
          <SlpIcon
            name="arrow-right"
            variant="product"
            size="medium"
            class="hero-scroll-gallery__icon"
          />
          {{ controls.next }}
        </SlpButton>
      </div>
    </div>
  </section>
</template>

<style scoped lang="scss">
.hero-scroll-gallery {
  background-position: 80% center;
  background-size: cover;
  overflow: hidden;

  &__container {
    position: relative;

    @media (min-width: $breakpoint-md) {
      display: flex;
      justify-content: center;
    }
    &--animate-hero {
      .hero-scroll-gallery__item {
        animation: spring 0.9s cubic-bezier(0.45, 0.05, 0.55, 0.95) forwards
          0.5s;
      }
    }
  }
  &__wrapper {
    position: relative;
    display: flex;
    overflow: auto;
    scroll-behavior: smooth;
    padding: $spacing-32 $spacing-32 $spacing-64 $spacing-32;
    opacity: 0;
    animation: items-fade 1s ease forwards 0.5s;
    scrollbar-width: none;
    &::-webkit-scrollbar {
      display: none;
      scrollbar-width: none;
    }
    @media (min-width: $breakpoint-lg) {
      padding: $spacing-64 $spacing-32 $spacing-96 $spacing-32;
    }
    @media (min-width: $breakpoint-xl) {
      padding: $spacing-64 $spacing-96 $spacing-96 $spacing-96;
    }
    @media (min-width: 2560px) {
      padding: $spacing-64 0 $spacing-96 0;
    }

    &--pressed {
      scroll-behavior: auto;
      .hero-scroll-gallery__item {
        pointer-events: none;
      }
    }
  }
  &__item {
    flex: 0 0 90%;
    margin-right: 40px;

    @media (min-width: $breakpoint-md) {
      flex: 0 0 460px;
    }
    &.hero-scroll-gallery__item--image {
      flex: 0 0 100%;
      margin: 0;
      max-width: 100%;
      display: none;
      :deep img {
        object-fit: cover;
        width: 100%;
      }
      @media (min-width: $breakpoint-md) {
        flex: 0 0 50%;
        display: block;
      }
      @media (min-width: $breakpoint-xl) {
        flex: 0 0 calc(1170px / 2);
      }
    }
    &.hero-scroll-gallery__item--card {
      margin-right: 40px;
      flex: 0 0 95%;
      max-width: 460px;

      @media (min-width: $breakpoint-md) {
        flex: 0 0 460px;
      }
      &:last-of-type {
        margin-right: 0;
      }
    }
    &.hero-scroll-gallery__item--block {
      display: none;
      margin-right: 40px;
      flex: 0 0 90%;
      max-width: 460px;

      @media (min-width: $breakpoint-md) {
        flex: 0 0 50%;
        display: block;
        max-width: 100%;
        margin-right: 0;
        @media (min-width: $breakpoint-xl) {
          flex: 0 0 calc(1170px / 2);
          margin-left: 64px;
        }
        &:nth-of-type(1) {
          flex: 0 0 460px;
          max-width: 460px;
          margin-right: 40px;
        }
      }
    }
  }
  &__image {
    flex: 0 0 650px;
    width: 650px;
    img {
      width: 100%;
      object-fit: fill;
    }
  }
  &__indicator {
    display: flex;
    align-items: center;
    position: absolute;
    bottom: $spacing-16;
    width: calc(100% - 64px);
    left: 0px;
    right: 0px;
    margin: 0 auto;

    @media (min-width: $breakpoint-md) {
      width: 50%;
      right: $spacing-32;
      left: auto;
      margin: 0 auto 0 0;
      bottom: $spacing-32;
    }
    @media (min-width: $breakpoint-lg) {
      width: 30%;
    }
    @media (min-width: $breakpoint-xl) {
      right: $spacing-64;
      right: calc((100% - 1170px) / 2);
    }
  }
  &__line {
    width: 100%;
    flex: 1 1 100%;
    height: 2px;
    background: white;
    opacity: 0.6;
    position: relative;
  }
  &__icon {
    width: 18px;
    height: 18px;
    color: #000;
    transition: all 0.3s ease;
    &.hero-scroll-gallery__icon--inactive {
      color: #fff;
      * {
        color: #fff;
      }
    }
  }
  &__position {
    position: absolute;
    background: black;
    left: 0;
    top: 0;
    height: 100%;
    transition: width 0.1s ease;
  }
  &__content-block {
    width: 100%;

    margin-top: 64px;
    @media (min-width: $breakpoint-md) {
      max-width: 460px;
      margin-right: 40px;
    }
    :deep .slp-btn {
      width: 100%;
      justify-content: center;
      margin-top: 16px;
      @media (min-width: $breakpoint-md) {
        width: inherit;
        justify-content: unset;
      }
    }
  }
  &__content-icon {
    height: 20px;
    width: 20px;
  }
  &__hide-on-desktop {
    display: block;
    @media (min-width: $breakpoint-md) {
      display: none;
    }
  }

  @keyframes spring {
    0% {
      transform: translateX(0px);
    }
    25% {
      transform: translateX(-25px);
    }
    50% {
      transform: translateX(20px);
    }
    75% {
      transform: translateX(0px);
    }
    100% {
      transform: translateX(0px);
    }
  }
  @keyframes items-fade {
    0% {
      opacity: 0;
    }
    100% {
      opacity: 1;
    }
  }
}
</style>
